Type Fram
	Field px#[14]	;point x-coord	-- set using AngPos(fr.fram,pnt)
	Field py#[14]	;point y-coord	-- set using Angpos(fr.fram,pnt)
	Field pa#[14]	;point angle
	Field pd#[14]	;point distance -- reference only
	
	Field actpnt	;The (index+1) of the Action Point. 0 means no Action Point specified.
	Field Selected  ;Used to determine whether this is the current frame
	Field parent    ;Pointer to Anim\ID
	Field FrameNum  ;An reference value to return the index of the frame - Starts at 0
	Field LastFrame ;A boolean reference as to whether this is the last frame
End Type

Type Anim
	Field Name$ 	  ;Name of the animation
	Field ID		  ;It's unique ID number, for fram\parent
	Field Player	  ;When a STK file is loaded, each animation is given the same Player number
					  ;  so that you can load more than one into memory and distinguish them.
	Field Loopfrom	  ;Which frame the animation will loop back to when it gets to the end
	Field Selected	  ;Determines whether this is the current animation
	Field TotalFrames ;A reference for the total number of frames in the animation
End Type


Function AbsX(fr.fram,pnt)
	;Retrieves the absolute x-coordinate of the points of the stickman
	;Absolute meaning from the CENTER, rather than from their parent points

	Select pnt
	Case 0
		Return fr\px[0]
	Case 1
		Return fr\px[0]+fr\px[1]
	Case 2
		Return fr\px[0]+fr\px[1]+fr\px[2]
	Case 3
		Return fr\px[0]+fr\px[3]
	Case 4
		Return fr\px[0]+fr\px[3]+fr\px[4]
	Case 5
		Return fr\px[0]+fr\px[5]
	Case 6
		Return fr\px[0]+fr\px[5]+fr\px[6]
	Case 7
		Return fr\px[0]+fr\px[5]+fr\px[6]+fr\px[7]
	Case 8
		Return fr\px[0]+fr\px[5]+fr\px[6]+fr\px[7]+fr\px[8]
	Case 9
		Return fr\px[0]+fr\px[5]+fr\px[6]+fr\px[9]
	Case 10
		Return fr\px[0]+fr\px[5]+fr\px[6]+fr\px[9]+fr\px[10]
	Case 11
		Return fr\px[0]+fr\px[5]+fr\px[6]+fr\px[11]
	End Select
End Function


Function AngPos(fr.fram,i=0)
	;Goes through each point and calculates the x,y based on the angle and distance
	;relative to each other. (x,y is relative to their parent points)
	;This should be called if ever you alter the angles of the points, so that
	;you can find out what the x,y coordinates are without worrying about Sin/Cos

	If i=0 Then fr\py[0]=fr\pd[0]
	If i=0 Or i=1 Then fr\px[1]=fr\pd[1]*Sin(fr\pa[1])
	If i=0 Or i=1 Then fr\py[1]=-fr\pd[1]*Cos(fr\pa[1])
	If i=0 Or i=2 Then fr\px[2]=fr\pd[2]*Sin(fr\pa[1]+fr\pa[2])
	If i=0 Or i=2 Then fr\py[2]=-fr\pd[2]*Cos(fr\pa[1]+fr\pa[2])
	If i=0 Or i=3 Then fr\px[3]=fr\pd[3]*Sin(fr\pa[3])
	If i=0 Or i=3 Then fr\py[3]=-fr\pd[3]*Cos(fr\pa[3])
	If i=0 Or i=4 Then fr\px[4]=fr\pd[4]*Sin(fr\pa[3]+fr\pa[4])
	If i=0 Or i=4 Then fr\py[4]=-fr\pd[4]*Cos(fr\pa[3]+fr\pa[4])
	If i=0 Or i=5 Then fr\px[5]=fr\pd[5]*Sin(fr\pa[5])
	If i=0 Or i=5 Then fr\py[5]=-fr\pd[5]*Cos(fr\pa[5])
	If i=0 Or i=6 Then fr\px[6]=fr\pd[6]*Sin(fr\pa[5]+fr\pa[6])
	If i=0 Or i=6 Then fr\py[6]=-fr\pd[6]*Cos(fr\pa[5]+fr\pa[6])
	If i=0 Or i=7 Then fr\px[7]=fr\pd[7]*Sin(fr\pa[5]+fr\pa[6]+fr\pa[7])
	If i=0 Or i=7 Then fr\py[7]=-fr\pd[7]*Cos(fr\pa[5]+fr\pa[6]+fr\pa[7])
	If i=0 Or i=8 Then fr\px[8]=fr\pd[8]*Sin(fr\pa[5]+fr\pa[6]+fr\pa[7]+fr\pa[8])
	If i=0 Or i=8 Then fr\py[8]=-fr\pd[8]*Cos(fr\pa[5]+fr\pa[6]+fr\pa[7]+fr\pa[8])
	If i=0 Or i=9 Then fr\px[9]=fr\pd[9]*Sin(fr\pa[5]+fr\pa[6]+fr\pa[9])
	If i=0 Or i=9 Then fr\py[9]=-fr\pd[9]*Cos(fr\pa[5]+fr\pa[6]+fr\pa[9])
	If i=0 Or i=10 Then fr\px[10]=fr\pd[10]*Sin(fr\pa[5]+fr\pa[6]+fr\pa[9]+fr\pa[10])
	If i=0 Or i=10 Then fr\py[10]=-fr\pd[10]*Cos(fr\pa[5]+fr\pa[6]+fr\pa[9]+fr\pa[10])
	If i=0 Or i=11 Then fr\px[11]=fr\pd[11]*Sin(fr\pa[5]+fr\pa[6]+fr\pa[11])
	If i=0 Or i=11 Then fr\py[11]=-fr\pd[11]*Cos(fr\pa[5]+fr\pa[6]+fr\pa[11])
End Function


Function AbsY(fr.fram,pnt)
	;Retrieves the absolute y-coordinate of the points of the stickman
	;Absolute meaning from the CENTER, rather than from their parent points
	
	Select pnt
	Case 0
		Return fr\py[0]
	Case 1
		Return fr\py[0]+fr\py[1]
	Case 2
		Return fr\py[0]+fr\py[1]+fr\py[2]
	Case 3
		Return fr\py[0]+fr\py[3]
	Case 4
		Return fr\py[0]+fr\py[3]+fr\py[4]
	Case 5
		Return fr\py[0]+fr\py[5]
	Case 6
		Return fr\py[0]+fr\py[5]+fr\py[6]
	Case 7
		Return fr\py[0]+fr\py[5]+fr\py[6]+fr\py[7]
	Case 8
		Return fr\py[0]+fr\py[5]+fr\py[6]+fr\py[7]+fr\py[8]
	Case 9
		Return fr\py[0]+fr\py[5]+fr\py[6]+fr\py[9]
	Case 10
		Return fr\py[0]+fr\py[5]+fr\py[6]+fr\py[9]+fr\py[10]
	Case 11
		Return fr\py[0]+fr\py[5]+fr\py[6]+fr\py[11]
	End Select
End Function


Function DrawStickMan(fr.fram,x,y,fx#=1,fy#=1,thck=1)
	;fr	   = the frame to draw
	;x,y   = the coordinates to draw the sickman
	;fx,fy = the scale factor of the stickman size and orientation
	For ox=-thck/2 To thck/2:For oy=-thck/2 To thck/2
		Origin x+ox,y+oy
		Line absx(fr,0)*fx,absy(fr,0)*fy,absx(fr,1)*fx,absy(fr,1)*fy
		Line absx(fr,1)*fx,absy(fr,1)*fy,absx(fr,2)*fx,absy(fr,2)*fy
		Line absx(fr,0)*fx,absy(fr,0)*fy,absx(fr,3)*fx,absy(fr,3)*fy
		Line absx(fr,3)*fx,absy(fr,3)*fy,absx(fr,4)*fx,absy(fr,4)*fy
		Line absx(fr,0)*fx,absy(fr,0)*fy,absx(fr,5)*fx,absy(fr,5)*fy
		Line absx(fr,5)*fx,absy(fr,5)*fy,absx(fr,6)*fx,absy(fr,6)*fy
		Line absx(fr,6)*fx,absy(fr,6)*fy,absx(fr,7)*fx,absy(fr,7)*fy
		Line absx(fr,7)*fx,absy(fr,7)*fy,absx(fr,8)*fx,absy(fr,8)*fy
		Line absx(fr,6)*fx,absy(fr,6)*fy,absx(fr,9)*fx,absy(fr,9)*fy
		Line absx(fr,9)*fx,absy(fr,9)*fy,absx(fr,10)*fx,absy(fr,10)*fy
	Next:Next
	Oval absx(fr,11)*fx-8*Abs(fx),absy(fr,11)*fy-8*Abs(fy),16*Abs(fx),16*Abs(fy)
	Origin 0,0
End Function


Function PulltoGround(fr.fram,level,fy#=1)
	;Returns the height at which the animation should be drawn so that it is level
	;with the ground + height of hip-joint. Just make sure you call it before drawing the Stickman.
	;fy = the scale factor of the stickman
	
	y=-1
	For i=0 To 11
		If (absy(fr,i)-absy(fr,0))*fy+y>level Or y=-1 Then y=level-(absy(fr,i)-absy(fr,0))*fy
	Next
	Return y
	
End Function


Function Load_Stickie(file$)
	;Loads a Stickie into memory. (No .STK needed)
	;Returns 1 if successful, otherwise 0
	f=ReadFile("stickies\"+file$+".STK")
	If f<>0 Then
		BestID=1:BestPlayer=1
		For ani.anim = Each anim
			If ani\ID=>BestID Then BestID=ani\ID+1
			If ani\Player=>BestPlayer Then BestPlayer=ani\Player+1
		Next
		
		anin=ReadShort(f)
		fran=ReadShort(f)
		For i=1 To anin
			ani.anim = New anim
			ani\name = ReadString(f)
			ani\ID = ReadShort(f)+BestID
			ani\LoopFrom = ReadShort(f)
			ani\player=BestPlayer
		Next
		For i=1 To fran
			fr.fram = New fram
			fr\parent = Int(ReadString(f))+BestID
			For j=0 To 11
				fr\pa[j]=ReadFloat(f)
				fr\pd[j]=ReadFloat(f)
			Next
			For j=1 To 11
				fr\pd[j]=18
				If j<=4 Then fr\pd[j]=24
				If j=11 Then fr\pd[j]=9
			Next
			obsoletevar= ReadByte(f)
			fr\actpnt = ReadByte(f)
			obsoletevar = ReadByte(f)
		Next
		CloseFile f
		
		For ani.anim = Each anim
			framen=0
			For fr.fram = Each fram
				If fr\parent = ani\ID
					fr\framenum = framen
					frb.fram = After fr
					If frb=Null Then
						fr\lastframe=True
					Else
						If frb\parent<>fr\parent Then fr\lastframe=True
					End If
					If fr\lastframe Then ani\totalframes = fr\framenum+1
					framen=framen+1
					AngPos(fr)
				End If
			Next
		Next
		
		Return 1
		
	Else
		Return 0
		
	End If
	
End Function


Function TweenVal#(a#,b#,t#)
	;Returns the value inbetween a# and b#, with t# as the tween value from 0 to 1
	Return a*(1-t)+b*t
End Function

Function TweenAngle#(a#,b#,t#)
	;Returns the angle inbetween a# and b#, with t# as the tween value from 0 to 1
	If a>b+180 Then b=b+360
	If b>a+180 Then a=a+360
	Return a*(1-t)+b*t
End Function